Subject: RE: mingw32 DLL getting main args?
From: "Colin Peters" <[email-masked]>
To: "GNU-win32" <[email-masked]>
Cc: "Khan Mumit" <[email-masked]>, <[email-masked]>
Date: Sun, 31 Oct 1999 22:39:29 +0900

Hello Mumit and Danny, I think this one is my fault, but I also think
I have (had?) an excuse. :)

The reason DLLs call getmainargs to parse the command line list
is so that they can provide the MS-like _argc and _argv variables for
access by functions within the DLL. Check init.c, which is #included
(yuck) in dllcrt1.c. If you like you can remove the declarations from
stdlib.h and work up a DLL version of init.c to remove the dependency
of your DLL on the C run-time library. (I suspect this hasn't changed
in Mumit's version, I must admit I only checked my source.)

I suppose the other reason I didn't worry much about this was that I
wasn't expecting people to write much DLL code without calling any
C library functions.

Mumit Khan [mailto:[email-masked]] wrote:
> Danny Sinclair <[email-masked]> writes:
> > Why does a DLL, made with Mumit's mingw32 2.95 release, need to call
> > msvcrt.dll's __getmainargs?
> >
> > When the DLLMainCRTStartup function receives DLL_PROCESS_ATTACH it calls
> > _mingw32_init_mainargs, which then calls __getmainargs. I don't want my
> > DLL to be dynamicly linked to msvcrt.dll, but it is because of this. Why
> > does a DLL need to parse the command line?
> >
>
> Good point. I don't know why it's done that way (it was there when I first
> used it). MSVC does not seem to do this, but DLLs created with MSVC are
> linked dynamically to MSVCRT.DLL (if you have /MD). I'll do some checking,
> and remove the getmainargs if it's not needed.

Cheers,
Colin.

--
Want to unsubscribe from this list?
Send a message to [email-masked]